#!/usr/bin/env python2
# -*- coding: UTF-8 -*-
#kate: syntax Python ;

import os
import sys
import subprocess

'''function 1 on F1 1 and NUM-1'''

global file_path
global list_file

def moveTo(where):
    os.system("echo \"" + golist_strings[where-1][1] + "\" > " + file_path)
    sys.exit()
    return "move to " + golist_strings[where-1][1] + " " + str(where)

import sys,os
import curses

global menuE
global e
global keychar
global golist_strings

e       = 0
menuE   = 1   # active entry
keychar = " " # like 1 or 2 ...
max_line_length = 0
go_list_off = 0
display_per_page = 10

class switch(object):
    value = None
    def __new__(class_, value):
        class_.value = value
        return True

def case(*args):
    return any((arg == switch.value for arg in args))


def draw_menu(stdscr):
    global menuE
    global e
    global keychar
    global max_line_length
    global go_list_off

    k        = 0
    cursor_x = 0
    cursor_y = 0

    # Clear and refresh the screen for a blank canvas
    stdscr.clear()
    stdscr.refresh()

    # Start colors in curses
    curses.start_color()
    curses.init_pair(1, curses.COLOR_CYAN,  curses.COLOR_BLACK)
    curses.init_pair(2, curses.COLOR_RED,   curses.COLOR_BLACK)
    curses.init_pair(3, curses.COLOR_BLACK, curses.COLOR_WHITE)

    # Loop where k is the last character pressed
    while (k != ord('q')):

        # Initialization
        stdscr.clear()
        height, width = stdscr.getmaxyx()

        ki              = int(k)
        try:    keychar = chr(k)
        except: keychar = 0
        callfunc        = False

        while switch(k):
            if case(10, 32 , 83):   # SPACE  ,   ENTER  ,   83 mouse middle
                callfunc = True
                break
            pass
            break

        if callfunc:
            e = moveTo(menuE)

        if k == curses.KEY_DOWN:
            if menuE < golist_cnt :
                cursor_y = cursor_y + 1
                menuE = menuE + 1

        elif k == curses.KEY_UP:
            if menuE > 1  :
                cursor_y = cursor_y - 1
                menuE = menuE - 1

        cursor_x = max(0, cursor_x)
        cursor_x = min(width-1, cursor_x)

        cursor_y = max(0, cursor_y)
        cursor_y = min(height-1, cursor_y)

        # Declaration of strings
        title        = "Choose where you want to go."[:width-1]
        statusbarstr = "Press 'q' to exit"

        # Centering calculations
        start_x_title    = int((  width // 2) - (len(title)    // 2) - len(title)    % 2)
        start_x_subtitle = int((  width // 2) - (max_line_length // 2) - max_line_length % 2)
        start_y          = int(( height // 2) -  (offset_y // 2) - (offset_y % 2)) - 1

        # Rendering some text
        #whstr = "Width: {}, Height: {} {}".format(width, height, menuE)
        #stdscr.addstr(0, 0, whstr, curses.color_pair(1))

        # Render status bar
        stdscr.attron(curses.color_pair(3))
        stdscr.addstr(height-1,  0, statusbarstr)
        stdscr.addstr(height-1, len(statusbarstr), " " * (width - len(statusbarstr) - 1))
        stdscr.attroff(curses.color_pair(3))

        # Turning on attributes for title
        stdscr.attron(curses.color_pair(2))
        stdscr.attron(curses.A_BOLD)

        # Rendering title
        stdscr.addstr(start_y, start_x_title, title)

        # Turning off attributes for title
        stdscr.attroff(curses.color_pair(2))
        stdscr.attroff(curses.A_BOLD)

        if display_per_page < menuE :
            go_list_off = menuE - display_per_page 

        name_idx = 0
        display_offset = 0;
        for (name, path) in golist_strings:
            name_idx = name_idx + 1

            if go_list_off > name_idx :
                continue

            if display_offset > display_per_page :
                break

            display_offset = display_offset + 1

            if name_idx == menuE :
                stdscr.attron(curses.color_pair(3))
                stdscr.attron( curses.A_BOLD)
            else  :  
                stdscr.attroff(curses.color_pair(3))
                stdscr.attroff(curses.A_BOLD)

            stdscr.addstr(start_y + 1 + display_offset,  start_x_subtitle, name + " - " + path)

        # Refresh the screen
        stdscr.refresh()

        # Wait for next input
        k = stdscr.getch()


def main():
    global file_path
    global golist_strings
    global golist_cnt
    global max_line_length
    global offset_y
    global list_file

    file_path = sys.argv[1]
    list_file = sys.argv[2]

    with open(list_file) as f:
        global golist_strings
        golist_strings = [tuple(map(lambda str:str.replace('\"', '').strip(), i.split(','))) for i in f]
    golist_cnt = len(golist_strings)

    max = 3
    for go in golist_strings :
        len_go = len(go[0]) + len(go[1]) + 3;
        if (len_go > max) :
            max = len_go

    max_line_length = max

    offset_y = 2 + display_per_page;

    curses.wrapper(draw_menu)

if __name__ == "__main__":
    main()

